//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace MonitoringClient.GatewayMonitoringService
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Listen To Server Messages command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ListenToServerMessagesRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _serverPattern;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ListenToServerMessagesRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="serverPattern">The pattern of the server UUID that is followed, can contain wildcards like *</param>
        public ListenToServerMessagesRequestDto(string serverPattern, Tecan.Sila2.IBinaryStore store)
        {
            ServerPattern = new Tecan.Sila2.StringDto(serverPattern, store);
        }
        
        /// <summary>
        /// The pattern of the server UUID that is followed, can contain wildcards like *
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ServerPattern
        {
            get
            {
                return _serverPattern;
            }
            set
            {
                _serverPattern = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/gateway/GatewayMonitoringService/v1/Command/ListenToServerMessag" +
                    "es";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ServerPattern, "serverPattern");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ServerPattern, "serverPattern"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the intermediate response of the Listen To Server Messages command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ListenToServerMessagesIntermediateDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private GatewayMonitoringMessageDto _intermediate;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ListenToServerMessagesIntermediateDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ListenToServerMessagesIntermediateDto(GatewayMonitoringMessage intermediate, Tecan.Sila2.IBinaryStore store)
        {
            Intermediate = new GatewayMonitoringMessageDto(intermediate, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public GatewayMonitoringMessageDto Intermediate
        {
            get
            {
                return _intermediate;
            }
            set
            {
                _intermediate = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Intermediate, "intermediate");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Intermediate, "intermediate"));
        }
    }
    
    /// <summary>
    /// The data transfer object for the Command State enumeration
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class CommandStateDto : Tecan.Sila2.ISilaTransferObject<CommandState>
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public CommandStateDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public CommandStateDto(CommandState inner, Tecan.Sila2.IBinaryStore store)
        {
            Value = inner.ToString();
        }
        
        /// <summary>
        /// The string representation of the given enum member
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public CommandState Extract(Tecan.Sila2.IBinaryStore store)
        {
            return ((CommandState)(System.Enum.Parse(typeof(CommandState), Value.Value)));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static CommandStateDto Create(CommandState inner, Tecan.Sila2.IBinaryStore store)
        {
            return new CommandStateDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// The data transfer object for State Update
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class StateUpdateDto : Tecan.Sila2.ISilaTransferObject<StateUpdate>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public StateUpdateDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public StateUpdateDto(StateUpdate inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        public Tecan.Sila2.RealDto Progress
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Progress;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Progress = value;
            }
        }
        
        public Tecan.Sila2.TimeDto EstimatedRemainingTime
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.EstimatedRemainingTime;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.EstimatedRemainingTime = value;
            }
        }
        
        public CommandStateDto State
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.State;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.State = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public StateUpdate Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new StateUpdate(Progress.Extract(store), EstimatedRemainingTime.Extract(store), State.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static StateUpdateDto Create(StateUpdate inner, Tecan.Sila2.IBinaryStore store)
        {
            return new StateUpdateDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((("" + Argument.Require(Progress, "progress")) 
                        + Argument.Require(EstimatedRemainingTime, "estimatedRemainingTime")) 
                        + Argument.Require(State, "state"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private Tecan.Sila2.RealDto _progress;
            
            private Tecan.Sila2.TimeDto _estimatedRemainingTime;
            
            private CommandStateDto _state;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(StateUpdate inner, Tecan.Sila2.IBinaryStore store)
            {
                Progress = new Tecan.Sila2.RealDto(inner.Progress, store);
                EstimatedRemainingTime = new Tecan.Sila2.TimeDto(inner.EstimatedRemainingTime, store);
                State = new CommandStateDto(inner.State, store);
            }
            
            [ProtoBuf.ProtoMemberAttribute(1)]
            public Tecan.Sila2.RealDto Progress
            {
                get
                {
                    return _progress;
                }
                set
                {
                    _progress = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.TimeDto EstimatedRemainingTime
            {
                get
                {
                    return _estimatedRemainingTime;
                }
                set
                {
                    _estimatedRemainingTime = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(3)]
            public CommandStateDto State
            {
                get
                {
                    return _state;
                }
                set
                {
                    _state = value;
                }
            }
        }
    }
    
    /// <summary>
    /// The data transfer object for the Message Type enumeration
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class MessageTypeDto : Tecan.Sila2.ISilaTransferObject<MessageType>
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public MessageTypeDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public MessageTypeDto(MessageType inner, Tecan.Sila2.IBinaryStore store)
        {
            Value = inner.ToString();
        }
        
        /// <summary>
        /// The string representation of the given enum member
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public MessageType Extract(Tecan.Sila2.IBinaryStore store)
        {
            return ((MessageType)(System.Enum.Parse(typeof(MessageType), Value.Value)));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static MessageTypeDto Create(MessageType inner, Tecan.Sila2.IBinaryStore store)
        {
            return new MessageTypeDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// The data transfer object for Gateway Monitoring Message
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class GatewayMonitoringMessageDto : Tecan.Sila2.ISilaTransferObject<GatewayMonitoringMessage>
    {
        
        private InnerStruct _inner;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public GatewayMonitoringMessageDto()
        {
            _inner = new InnerStruct();
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public GatewayMonitoringMessageDto(GatewayMonitoringMessage inner, Tecan.Sila2.IBinaryStore store)
        {
            _inner = new InnerStruct(inner, store);
        }
        
        public MessageTypeDto Type
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Type;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Type = value;
            }
        }
        
        public Tecan.Sila2.StringDto ServerUuid
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.ServerUuid;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.ServerUuid = value;
            }
        }
        
        public Tecan.Sila2.StringDto Identifier
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Identifier;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Identifier = value;
            }
        }
        
        public Tecan.Sila2.TimestampDto Time
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.Time;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.Time = value;
            }
        }
        
        public StateUpdateDto StateUpdate
        {
            get
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                return Inner.StateUpdate;
            }
            set
            {
                if ((_inner == null))
                {
                    _inner = new InnerStruct();
                }
                Inner.StateUpdate = value;
            }
        }
        
        /// <summary>
        /// The actual contents of the data transfer object.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public InnerStruct Inner
        {
            get
            {
                return _inner;
            }
            set
            {
                _inner = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public GatewayMonitoringMessage Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new GatewayMonitoringMessage(Type.Extract(store), ServerUuid.Extract(store), Identifier.Extract(store), Time.Extract(store), StateUpdate.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static GatewayMonitoringMessageDto Create(GatewayMonitoringMessage inner, Tecan.Sila2.IBinaryStore store)
        {
            return new GatewayMonitoringMessageDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ((((("" + Argument.Require(Type, "type")) 
                        + Argument.Require(ServerUuid, "serverUuid")) 
                        + Argument.Require(Identifier, "identifier")) 
                        + Argument.Require(Time, "time")) 
                        + Argument.Require(StateUpdate, "stateUpdate"));
        }
        
        /// <summary>
        /// Represents the inner structure for actual content
        /// </summary>
        [ProtoBuf.ProtoContractAttribute()]
        public class InnerStruct
        {
            
            private MessageTypeDto _type;
            
            private Tecan.Sila2.StringDto _serverUuid;
            
            private Tecan.Sila2.StringDto _identifier;
            
            private Tecan.Sila2.TimestampDto _time;
            
            private StateUpdateDto _stateUpdate;
            
            /// <summary>
            /// Initializes a new instance (to be used by the serializer)
            /// </summary>
            public InnerStruct()
            {
            }
            
            /// <summary>
            /// Initializes a new data transfer object from the business object
            /// </summary>
            /// <param name="inner">The business object that should be transferred</param>
            /// <param name="store">A component to handle binary data</param>
            public InnerStruct(GatewayMonitoringMessage inner, Tecan.Sila2.IBinaryStore store)
            {
                Type = new MessageTypeDto(inner.Type, store);
                ServerUuid = new Tecan.Sila2.StringDto(inner.ServerUuid, store);
                Identifier = new Tecan.Sila2.StringDto(inner.Identifier, store);
                Time = new Tecan.Sila2.TimestampDto(inner.Time, store);
                StateUpdate = new StateUpdateDto(inner.StateUpdate, store);
            }
            
            [ProtoBuf.ProtoMemberAttribute(1)]
            public MessageTypeDto Type
            {
                get
                {
                    return _type;
                }
                set
                {
                    _type = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(2)]
            public Tecan.Sila2.StringDto ServerUuid
            {
                get
                {
                    return _serverUuid;
                }
                set
                {
                    _serverUuid = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(3)]
            public Tecan.Sila2.StringDto Identifier
            {
                get
                {
                    return _identifier;
                }
                set
                {
                    _identifier = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(4)]
            public Tecan.Sila2.TimestampDto Time
            {
                get
                {
                    return _time;
                }
                set
                {
                    _time = value;
                }
            }
            
            [ProtoBuf.ProtoMemberAttribute(5)]
            public StateUpdateDto StateUpdate
            {
                get
                {
                    return _stateUpdate;
                }
                set
                {
                    _stateUpdate = value;
                }
            }
        }
    }
}
